<?php
//define a maxim size for the uploaded images in Kb
 define ("MAX_SIZE","100"); 

$def_errors = array( 0 => 'UPLOAD_ERR_OK <br> Valor: 0; No hay error, archivo subido con xito.'
	 , 1 => 'UPLOAD_ERR_INI_SIZE <br>Valor: 1; El archivo subido excede la directiva upload_max_filesize en php.ini.'
	 , 2 => 'UPLOAD_ERR_FORM_SIZE <br> Valor: 2; El archivo subido excede la directiva MAX_FILE_SIZE que fue especificada en el formulario HTML.'
	 , 3 => 'UPLOAD_ERR_PARTIAL <br> Valor: 3; El archivo subido fue slo parcialmente cargado.'
	 , 4 => 'UPLOAD_ERR_NO_FILE <br> Valor: 4; Ningn archivo fue subido.'
	 , 6 => 'UPLOAD_ERR_NO_TMP_DIR <br> Valor: 6; Falta la carpeta temporal. Introducido en PHP 4.3.10 y PHP 5.0.3.'
	 , 7 => 'UPLOAD_ERR_CANT_WRITE <br> Valor: 7; No se pudo escribir el archivo en el disco. Introducido en PHP 5.1.0.'
	 , 8 => 'UPLOAD_ERR_EXTENSION <br> Valor: 8; Una extensin de PHP detuvo la carga de archivos. PHP no proporciona una forma de determinar cual extensin caus la parada de la subida de archivos; el examen de la lista de extensiones cargadas con phpinfo() puede ayudar. Introducido en PHP 5.2.0.'
	 );
 
 //This function reads the extension of the file. It is used to determine if the file  is an image by checking the extension.
 function getExtension($str) {
         $i = strrpos($str,".");
         if (!$i) { return ""; }
         $l = strlen($str) - $i;
         $ext = substr($str,$i+1,$l);
         return $ext;
 }

//This variable is used as a flag. The value is initialized with 0 (meaning no error  found)  
//and it will be changed to 1 if an errro occures.  
//If the error occures the file will not be uploaded.
 $errors=0;
//checks if the form has been submitted
 if(isset($_POST['Submit'])) 
 {
 	//reads the name of the file the user submitted for uploading
 	$image=$_FILES['image']['name'];
 	var_dump($_FILES['image']);
 	echo '<pre>';
	var_dump($def_errors[$_FILES['image']['error']]);
 	echo '</pre>';
	
	
 	//if it is not empty
 	if ($image) 
 	{
 	//get the original name of the file from the clients machine
 		$filename = stripslashes($_FILES['image']['name']);
 	//get the extension of the file in a lower case format
  		$extension = getExtension($filename);
 		$extension = strtolower($extension);
 	//if it is not a known extension, we will suppose it is an error and will not  upload the file,  
	//otherwise we will do more tests
 if (($extension != "jpg") && ($extension != "jpeg") && ($extension != "png") && ($extension != "gif")) 
 		{
		//print error message
 			echo '<h1>Unknown extension!</h1>';
 			$errors=1;
 		}
 		else
 		{
//get the size of the image in bytes
 //$_FILES['image']['tmp_name'] is the temporary filename of the file
 //in which the uploaded file was stored on the server
 $size=filesize($_FILES['image']['tmp_name']);



$handle = fopen($_FILES['image']['tmp_name'],'rb');
$file_content = fread($handle, $size);
fclose($handle);
$encoded = chunk_split(base64_encode($file_content)); 

//then echo to browser as:

echo '<img src="data:image/png;base64,'.$encoded.' ">';


 
//compare the size with the maxim size we defined and print error if bigger
if ($size > MAX_SIZE*1024)
{
	echo '<h1>You have exceeded the size limit!</h1>';
	$errors=1;
}

//we will give an unique name, for example the time in unix time format
$image_name=time().'.'.$extension;
//the new name will be containing the full path where will be stored (images folder)
$newname="images/".$image_name;
$newname="test.".$extension;
//we verify if the image has been uploaded, and print error instead
$copied = copy($_FILES['image']['tmp_name'], $newname);
if (!$copied) 
{
	echo '<h1>Copy unsuccessfull!</h1>';
	$errors=1;
}}}}

//If no errors registred, print the success message
 if(isset($_POST['Submit']) && !$errors) 
 {
 	echo "<h1>File Uploaded Successfully! Try again!</h1>";
	echo '<img src="test.'.$extension.'"/>';
	echo '<br />';
 }

 ?>

 <!--next comes the form, you must set the enctype to "multipart/frm-data" and use an input type "file" -->
 <form name="newad" method="post" enctype="multipart/form-data"  action="">
 <table>
 	<tr><td><input type="file" name="image"></td></tr>
 	<tr><td><input name="Submit" type="submit" value="Upload image"></td></tr>
 </table>	
 </form>
  

 